// X(X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i;
	unsigned char id[] = "-- SAZIRI -- Sys ";

	// OPMpȃf[^
	struct fpos ma[] =
	{
		{ 0x2c, 0x01, 0x0000, 0x0f00 },	// RX101
		{ 0x2c, 0x05, 0x0000, 0x0700 },	// SAZIRI RX201
		{ 0x2d, 0x02, 0x0000, 0x0700 },	// BX101
		{ 0x2d, 0x04, 0x0000, 0x0a00 },	// BX201
		{ 0x2e, 0x01, 0x0200, 0x0500 },	// VX101
		{ 0x2e, 0x03, 0x0000, 0x0800 },	// SAZI VISUAL VX
		{ 0x2e, 0x05, 0x0100, 0x0400 },	// GOEMON GOEX01
		{ 0x2f, 0x02, 0x0000, 0x0200 },	// SAZIRI GAME OVE
		{ 0x2f, 0x02, 0x0300, 0x1200 },	// SAZIRI RPGX01
		{ 0x30, 0x02, 0x0100, 0x1800 },	// XSAOP Syncrotro
		{ 0x31, 0x03, 0x0100, 0x1e00 },	// XSAHP "Breese of
		{ 0x00, 0x00, 0x0000, 0x2000 },	// 
	};

	// PSGpȃf[^
	struct fpos mb[] =
	{
		{ 0x0d, 0x01, 0x0000, 0x0500 },	// RXP101
		{ 0x0d, 0x02, 0x0100, 0x0400 },	// RXP201
		{ 0x0d, 0x03, 0x0200, 0x0400 },	// BXP101
		{ 0x0d, 0x04, 0x0300, 0x0500 },	// BXP201
		{ 0x0e, 0x01, 0x0100, 0x0400 },	// VXP101
		{ 0x0e, 0x02, 0x0100, 0x0300 },	// SAZIRI VXP201
		{ 0x0e, 0x03, 0x0100, 0x0300 },	// GOEPX1
		{ 0x0e, 0x04, 0x0000, 0x0100 },	// SAZIRI GOXP01
		{ 0x0e, 0x04, 0x0200, 0x0200 },	// SAZIRI RPGXP1
		{ 0x0e, 0x05, 0x0000, 0x0c00 },	// PSAOP SAJIRI OP
		{ 0x0f, 0x03, 0x0000, 0x0d00 },	// PSAHP "Breese of
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x13);
		disk.SetRecordRange(0x01,0x05);
		// IPL̕ŃfBXN𔻒
		if (!memcmp(&buff[1], id, sizeof(id)))
		{
			printf("DISK 0 F܂.\n");
			// CvO
			fcut("MUSMOD", 0x42, 0x21, 0x00, 0x01, 0x03, 0x0000, 0x1400);
			fcut("OPMDRV", 0x01, 0x00, 0x01, 0x02, 0x03, 0x0000, 0x2000);
			fcut("PSGDRV", 0x03, 0x01, 0x01, 0x02, 0x03, 0x0000, 0x2000);

			// ȃf[^̐؂o
			for (i=0; ma[i].sec; i++)
			{
				sprintf(fname,"MA%03d",i);
				fcut(fname, ma[i].trk, ma[i].trk>>1, ma[i].trk&1, ma[i].sec, 0x03, ma[i].ofs, ma[i].size);
			}
			for (i=0; mb[i].sec; i++)
			{
				sprintf(fname,"MB%03d",i);
				fcut(fname, mb[i].trk, mb[i].trk>>1, mb[i].trk&1, mb[i].sec, 0x03, mb[i].ofs, mb[i].size);
			}
		}
	}
	return 0;
}

